ZUpload: 
zzz_FS   = arg(1);  /* Diese Datei (inkl. Header) wird ...     */
FileSpec = arg(2);  /* ... unter diesem Std-Namen hochgeladen  */
QDoZip   = ( arg(3)<>"NOZIP" );

/* "EF_Act_HTTPDir" = arg(3);
   "EF_Act_RPath"   = arg(4);			*/

BakDir = directory();

Call XSay "Generating upload-file...."FileSpec;

if( \QDoZip ) then do
   LocalFile  = zzz_FS;
   SIGNAL AROUND1;  /* skip gz-Verarbeitung 	*/
end;

nok = SysFileDelete(FileSpec);
if nok = 0 | nok = 2 then NOP;
else;do
   Err = "Unexpected error ('"nok"')";
   if nok =  5 then Err = "Access denied";
   if nok = 32 then Err = "Sharing violation";
   Call XSay "Error deleting upload-file '"FileSpec"': "Err"!";
   ok = directory(BakDir);
   RETURN 0;
end;

if(0) then 
  Content = CharIn(zzz_FS, 1, Chars(zzz_FS) );    /* inkl. Header-Record (nur bei Art) */
else;do
   /* ----------------------				*/
   /* Special-Tags auflsen:				*/
   /* ----------------------				*/
   /* "<#- Type=SingImg " || LeftSide  Img_FN  Img_SubTit Img_Dims DsplWidth V#C#S#U -#>	*/
   pgui_ID1 = "<#- ";	/* Abstimmen mit phpGUI, PB_Img_Create	*/
   pgui_ID2 = " -#>";
   do while lines(zzz_FS) > 0
      Rec = LineIn(zzz_FS);
      if left(Rec,length(pgui_ID1)) = pgui_ID1 then do
         Call XSay "Found Special-Tag '" || word(Rec,2) || "'";

         Rec = Subword(Rec,2, words(Rec)-2);	/* strip '<#- ... -#>'	*/
         Type = word(Rec,1);

         if Type = "Type=Include" then do; Call Resolv_IncFile Rec, FileSpec; ITERATE; end;
         if Type = "Type=SingImg" then do; Call Resolv_SingImg Rec, FileSpec; ITERATE; end;
         if Type = "Type=ImgGal"  then do; Call Resolv_ImgGal  Rec, FileSpec; ITERATE; end;
      end;
      ok = LineOut(FileSpec, Rec);	/* unverndert ausgeben		*/
   end;
end;

ok = stream(FileSpec, "c","close");
ok = stream(zzz_FS,   "c","close");

/* ---------------------------  */
/* Step-2: Packen (gz-Format):  */
/* ---------------------------  */

if \LoadDLL('RXGZLIB', 'rxgzLoadFuncs') then do  /* Lib zum Erzeugen eines gzip-Formates  */
   Call XSay "RXGZLIB not found - transferring data uncompressed";
   LocalFile  = FileSpec;
   FileType = ".uc";  /* (uncompressed)  */
end;
else;do
   Call XSay "Making gz-file....";

   FileType = ".gz";

   gzipFile = FileSpec||FileType;

   Option = "9";   /* Max. compression-rate                    */
   rc = rxgzDeflateFile(FileSpec, gzipFile, Option);    /* 0=ok */
   ok = SysSleep(1);
   Call XSay "Making gz-file....done! ("rc")",,"REPL";

   Call XSay "Uploading "gzipFile"....";
   LocalFile  = gzipFile;
end;

AROUND1:

/* ---------------------------  */
/* Step-3: Uploading xx_File:   */
/* ---------------------------  */

/* ZFTP_Logon() ist schon ausserhalb passiert, aber FtpLogoff() hier unten	*/

/* ---------------------------  */
/* Nun Datei hochladen:         */
/* ---------------------------- */
RemoteFile = filespec("name",LocalFile);

Mode = "Binary";

/* ------------------------------------------------             */
/* Zuerst Ziel-Pfad auf dem Remote Server bestimmen             */
/* ------------------------------------------------             */

/* ++ das funzt nur, solange nur ein Dir existiert		*/

Remote_SubDir = VRGet("EF_Act_HTTPDir","Value") || VRGet("EF_Act_RPath","Value");

Remote_SubDir = strip(Remote_SubDir,"T","/") || "/";  /* immer mit / enden	*/
Remote_SubDir = "/" || strip(Remote_SubDir,"L","/");  /* immer mit / beginnen	*/

Call XSay "Einloggen in Remote_SubDir="Remote_SubDir"!";

if(0) then ok = FtpChDir("/");ok = ZFTPAfter("Initial ChDir to root!",ok);

ok = FtpChDir(Remote_SubDir);ok = ZFTPAfter("Initial ChDir",Remote_SubDir);

Call XSay "Uploading '"LocalFile"' to '"Remote_SubDir || RemoteFile"'...";

ok = SysFileTree(LocalFile,"files.","F");
if files.0 <> 1 then do
   Call Xsay "Sysfail - '"LocalFile"' not found!";
   RETURN -1;
end;

rc = FtpPut(LocalFile,RemoteFile,Mode);nok=ZFTPAfter("Put",RemoteFile);
if nok <> 0 then do
   Call Xsay "rc="rc", PUT fr Datei '"LocalFile"' nach '"RemoteFile"' nicht erfolgreich ("ZFTPErr(FTPERRNO)")";
   nok = 1;
end;
else;do
   if ( FileType = "PHP" ) then do 	/* kommt hier eigentlich nie (?) vor ... */
   
      QuoteString = "site chmod 777 "RemoteFile;
      Call XSay "Setting attribute to executable...("QuoteString")";
      rc = FtpQuote(QuoteString);nok=ZFTPAfter("quote site chmod",RemoteFile);
      if nok <> 0 then do
         Call Xsay "rc="rc", QUOTE(Chmod) failed for file "RemoteFile" ("ZFTPErr(FTPERRNO)")";
         nok = 1;
      end;
      else;do
        /* File erfolgreich uploaded:                              */
        Call Xsay "Upload '"LocalFile"' to '"RemoteFile"' successful";
      end;
   end;
end;
/* ---------------------------  */

say "NOK="NOK"!";
return \NOK RemoteFile;		/* 1: OK	*/


/* ---------------------------	*/
/* Log. Subroutines:		*/
/* ---------------------------	*/


/* ---------------------------	*/
Resolv_IncFile:
Rec     = arg(1);
OutFile = arg(2);

MacroFile = word(Rec,2);	/* hinter 'Type=Include'	*/

do while lines(MacroFile) > 0
   ok = LineOut(OutFile, Linein(MacroFile));
end;
ok = stream(MacroFile,"c","close");

return 0;

/* ---------------------------	*/
Resolv_SingImg: Procedure;
Rec     = arg(1);
OutFile = arg(2);

     LeftSide   = word(Rec,2);	/* {1|0}	*/
     Img_FN     = word(Rec,3);
     Img_Dims   = word(Rec,4);
     DsplWidth  = word(Rec,5);
     VCSU       = word(Rec,6);
     Img_SubTit = Subword(Rec,7);

     parse value Img_Dims with Img_Width "#" Img_Height;
     parse value VCSU with V "#" C "#" S "#" U;

     HTML = "0D0A";

     if (LeftSide) then
        HTML = "<div style=""float:left; margin-right:";
     else;
        HTML = "<div style=""float:right; margin-left:";


     HTML = HTML || "6px;margin-top:4px;margin-bottom:4px;"">";
     HTML = HTML || "<table border=0 cellspacing=0 cellpadding=6 style=""border:1px solid #223322; background-color:#edE8FF;"">";
     HTML = HTML || "<tr><td>";
     HTML = HTML || "<a href=""Javascript:OpenWin('auxwin.php?V="V"&C="C"&S="S"&U="U"&What="Img_FN"',"Img_Width+30","Img_Height+50",'scroll');"">";
     HTML = HTML || "<img src='"Img_FN"' width=" || DsplWidth || "></td></tr>";
     HTML = HTML || "<tr><td align=center><font size='-1'> "Img_SubTit" </font></td></tr></table>";
     HTML = HTML || "</div>";

     ok = LineOut(OutFile, HTML);
return 0;

/* ---------------------------	*/
Resolv_ImgGal:
return 0;

/* ---------------------------	*/
XSay: Procedure;
What = strip(arg(1));
Text = strip(arg(2));
if What = "" ,
 | What = "TOF" ,
 | What = "BOF" then RETURN "";

say date()"-"substr(time(),1,8)"=>"Text What;
return Text What;

/* --------------------	*/
ZFTPAfter: procedure Expose FTPErrno;
What = arg(1);
Parm = arg(2);

/* -------------------------------------------------------------------  */
/* ZFTPAfter: Allgemeine ftp-errno-Auswertung:                          */
/* -------------------------------------------------------------------  */

if FTPErrno <> 0 then do
   Call Xsay "Error nach "What"/"Parm": "ZFTPErr(FTPErrno)"!";
end;
else;
   Call Xsay "Successful completion of "What"/"Parm"!";

return FTPErrno;

/* -------------------------            */
/* ZFTPErr:                             */
/* -------------------------            */
ZFTPErr: procedure
Errno = arg(1);

Select
  WHEN      Errno = "FTPSERVICE"   THEN do;Return "unknown service";end;
  WHEN      Errno = "FTPHOST"      THEN do;Return "unknown host";end;
  WHEN      Errno = "FTPSOCKET"    THEN do;Return "unable to obtain socket";end;
  WHEN      Errno = "FTPCONNECT"   THEN do;Return "unable to connect to server";end;
  WHEN      Errno = "FTPLOGIN"     THEN do;Return "login failed";end;
  WHEN      Errno = "FTPABORT"     THEN do;Return "transfer aborted";end;
  WHEN      Errno = "FTPLOCALFILE" THEN do;Return "problem openning local file";end;
  WHEN      Errno = "FTPDATACONN"  THEN do;Return "problem initializing data connection";end;
  WHEN      Errno = "FTPCOMMAND"   THEN do;Return "command failed (prpbly file not found)";end;
  WHEN      Errno = "FTPPROXYTHIRD"THEN do;Return "proxy server does not support third party transfers";end;
  WHEN      Errno = "FTPNOPRIMARY" THEN do;Return "no primary connection for proxy transfer";end;
  OTHERWISE
      do;Return "<unknown FTP-returncode> "Errno;end;

return 0;
